package com.yongqi.xinrenli.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import com.yongqi.xinrenli.domain.bo.DbUserCouponBo;
import com.yongqi.xinrenli.domain.vo.DbUserCouponVo;
import com.yongqi.xinrenli.domain.DbUserCoupon;
import com.yongqi.xinrenli.mapper.DbUserCouponMapper;
import com.yongqi.xinrenli.service.IDbUserCouponService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 用户优惠券关联Service业务层处理
 *
 * @author zyf
 * @date 2023-03-09
 */
@RequiredArgsConstructor
@Service
public class DbUserCouponServiceImpl implements IDbUserCouponService {

    private final DbUserCouponMapper baseMapper;

    /**
     * 查询用户优惠券关联
     */
    @Override
    public DbUserCouponVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 查询用户优惠券关联列表
     */
    @Override
    public TableDataInfo<DbUserCouponVo> queryPageList(DbUserCouponBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<DbUserCoupon> lqw = buildQueryWrapper(bo);
        Page<DbUserCouponVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询用户优惠券关联列表
     */
    @Override
    public List<DbUserCouponVo> queryList(DbUserCouponBo bo) {
        LambdaQueryWrapper<DbUserCoupon> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<DbUserCoupon> buildQueryWrapper(DbUserCouponBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<DbUserCoupon> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getCouponId() != null, DbUserCoupon::getCouponId, bo.getCouponId());
        lqw.eq(bo.getUserId() != null, DbUserCoupon::getUserId, bo.getUserId());
        lqw.eq(bo.getUseStatus() != null, DbUserCoupon::getUseStatus, bo.getUseStatus());
        lqw.eq(bo.getModifyTime() != null, DbUserCoupon::getModifyTime, bo.getModifyTime());
        return lqw;
    }

    /**
     * 新增用户优惠券关联
     */
    @Override
    public Boolean insertByBo(DbUserCouponBo bo) {
        DbUserCoupon add = BeanUtil.toBean(bo, DbUserCoupon.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改用户优惠券关联
     */
    @Override
    public Boolean updateByBo(DbUserCouponBo bo) {
        DbUserCoupon update = BeanUtil.toBean(bo, DbUserCoupon.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(DbUserCoupon entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除用户优惠券关联
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
